=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2008-06-30 08:38:49 +0000
+++ loggerhead/controllers/__init__.py	2008-07-01 02:38:56 +0000
@@ -66,38 +66,34 @@
         kw = dict(parse_querystring(environ))
         util.set_context(kw)
 
-        h._branch.lock_read()
-        try:
-            args = []
-            while 1:
-                arg = path_info_pop(environ)
-                if arg is None:
-                    break
-                args.append(arg)
-
-            vals = {
-                'branch': self._branch,
-                'util': util,
-                'history': h,
-                'url': self._branch.context_url,
-            }
-            vals.update(templatefunctions)
-            headers = {}
-            vals.update(self.get_values(h, args, kw, headers))
-
-            self.log.info('Getting information for %s: %r secs' % (
-                self.__class__.__name__, time.time() - z,))
-            if 'Content-Type' not in headers:
-                headers['Content-Type'] = 'text/html'
-            writer = start_response("200 OK", headers.items())
-            template = load_template(self.template_path)
-            z = time.time()
-            w = BufferingWriter(writer, 8192)
-            template.expand_into(w, **vals)
-            w.flush()
-            self.log.info('Rendering %s: %r secs, %s bytes, %s (%2.1f%%) bytes saved' % (
-                self.__class__.__name__, time.time() - z, w.bytes, w.bytes_saved, 100.0*w.bytes_saved/w.bytes))
-            return []
-        finally:
-            h._branch.unlock()
+        args = []
+        while 1:
+            arg = path_info_pop(environ)
+            if arg is None:
+                break
+            args.append(arg)
+
+        vals = {
+            'branch': self._branch,
+            'util': util,
+            'history': h,
+            'url': self._branch.context_url,
+        }
+        vals.update(templatefunctions)
+        headers = {}
+        vals.update(self.get_values(h, args, kw, headers))
+
+        self.log.info('Getting information for %s: %r secs' % (
+            self.__class__.__name__, time.time() - z,))
+        if 'Content-Type' not in headers:
+            headers['Content-Type'] = 'text/html'
+        writer = start_response("200 OK", headers.items())
+        template = load_template(self.template_path)
+        z = time.time()
+        w = BufferingWriter(writer, 8192)
+        template.expand_into(w, **vals)
+        w.flush()
+        self.log.info('Rendering %s: %r secs, %s bytes, %s (%2.1f%%) bytes saved' % (
+            self.__class__.__name__, time.time() - z, w.bytes, w.bytes_saved, 100.0*w.bytes_saved/w.bytes))
+        return []
 

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2008-06-25 00:00:19 +0000
+++ loggerhead/controllers/atom_ui.py	2008-07-01 02:38:56 +0000
@@ -25,7 +25,6 @@
     template_path = 'loggerhead.templates.atom'
 
     def get_values(self, h, args, kw, headers):
-        h = self._branch.history
 
         pagesize = int(20)#self._branch.config.get('pagesize', '20'))
 

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2008-06-25 06:05:09 +0000
+++ loggerhead/controllers/download_ui.py	2008-07-01 02:38:56 +0000
@@ -29,42 +29,39 @@
 
 class DownloadUI (object):
 
-    def __init__(self, branch):
-        # BranchView object
+    def __init__(self, branch, history):
         self._branch = branch
+        self._history = history
         self.log = branch.log
 
     def __call__(self, environ, start_response):
         # /download/<rev_id>/<file_id>/[filename]
         z = time.time()
-        h = self._branch.history
-
-        h._branch.lock_read()
-        try:
-            args = []
-            while 1:
-                arg = path_info_pop(environ)
-                if arg is None:
-                    break
-                args.append(arg)
-
-            if len(args) < 2:
-                raise httpexceptions.HTTPMovedPermanently(self._branch.url('../changes'))
-
-            revid = h.fix_revid(args[0])
-            file_id = args[1]
-            path, filename, content = h.get_file(file_id, revid)
-            mime_type, encoding = mimetypes.guess_type(filename)
-            if mime_type is None:
-                mime_type = 'application/octet-stream'
-
-            self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
-            headers = [
-                ('Content-Type', mime_type),
-                ('Content-Length', len(content)),
-                ('Content-Disposition', 'attachment; filename=%s'%(filename,)),
-                ]
-            start_response('200 OK', headers)
-            return [content]
-        finally:
-            h._branch.unlock()
+
+        h = self._history
+
+        args = []
+        while 1:
+            arg = path_info_pop(environ)
+            if arg is None:
+                break
+            args.append(arg)
+
+        if len(args) < 2:
+            raise httpexceptions.HTTPMovedPermanently(self._branch.url('../changes'))
+
+        revid = h.fix_revid(args[0])
+        file_id = args[1]
+        path, filename, content = h.get_file(file_id, revid)
+        mime_type, encoding = mimetypes.guess_type(filename)
+        if mime_type is None:
+            mime_type = 'application/octet-stream'
+
+        self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
+        headers = [
+            ('Content-Type', mime_type),
+            ('Content-Length', len(content)),
+            ('Content-Disposition', 'attachment; filename=%s'%(filename,)),
+            ]
+        start_response('200 OK', headers)
+        return [content]

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-07-01 02:34:19 +0000
+++ loggerhead/history.py	2008-07-01 02:38:56 +0000
@@ -178,6 +178,8 @@
     for a particular branch, open it, read-lock it, wrap a History object
     around it, serve the request, throw the History object away, unlock the
     branch and throw it away.
+
+    :ivar _file_change_cache: xx
     """
 
     def __init__(self, branch, whole_history_data_cache):

